;I2C routine
;SCL .. serial clocks
;SDA .. serial data

NAME             		FUNC_ASM
?PR?FUNC?IIC		SEGMENT CODE
?DT?FUNC?IIC		SEGMENT DATA OVERLAYABLE
?BI?FUNC?IIC		SEGMENT BIT OVERLAYABLE
;

SDA			bit	P1.2
SCL			bit	P1.3

;SDA			bit	P3.5 verze pro maly proc
;SCL			bit	P3.4
;CHYBA		bit 2
;

public IISTART
public _IIWR
public _IIRE,_IIRE?BIT
public IISTOP
;
;
;EXTRN bit ( SCL, SDA)
;  int IIC_start( unsigned char IIC_byte); 
;  int IIC_write( unsigned char IIC_byte); 
;  int IIC_read( bit ACK); 
;  void IIC_stop( void);
;

RSEG ?BI?FUNC?IIC

_IIRE?BIT:
NOACK:	dbit 1

RSEG ?PR?FUNC?IIC
	
;******************************
; Send 8 bits from ACC via IIC
;******************************

_IIWR:	mov R5,#08		; will send 8 bits
			mov A,R7			; exchanging register
			mov B,#01		; multiply x1 - doesn't affect A
BYTE:		rlc A				; first it to carry, MSB is first
			jc JEDNA			; it is 1
			clr SDA			; it is 0
			jmp OK
JEDNA:	setb SDA
OK:		nop				; DATA has to be valid for a moment
			nop
			nop
			setb SCL			; sync clocks
			nop
			mul AB			; wait 4 cycles
			mov B,#01		; multiply x1 - doesn't affect A
			clr SCL			; the end of transfer cycle
			djnz R5,BYTE	; transfer all 8 bits
			setb SDA			; release for ACK
			nop
			mul AB			; wait 4 cycles
			mov B,#01		; multiply x1 - doesn't affect A
			setb SCL
			mul AB			; wait 4 cycles

;			jnb SDA,PREOK	; je ACK=0, prenos je dobry
;			setb CHYBA		; nastavi chybovy bit
;			clr SCL
;			ret	
;PREOK:	nop			
;			clr CHYBA		; je to ok

			clr SCL			; the end of ACK
			ret				; the end of transfer
;****************************************************************	
	
IISTOP:	clr SDA			; stop condition
			mul AB			; wait 4 cycles
			setb SCL
			mul AB			; wait 4 cycles
			setb SDA			; the end
			ret

IISTART:	setb SCL			; start condition
			setb SDA
			nop				; implus 5us
			mul AB
			clr SDA			; start
			nop
			mul AB			; wait 4 cycles
			clr SCL			
			ret
	
;*********************************
; read 8 bits from I2C
;*********************************
_IIRE:	mov A,#00		; prepare ACC
			mov R5,#8		; will read 8 bits
			mov B,#01h		; multiply x1 doesn't affect A
			setb SDA
CTI:		setb SCL
			mul AB			; wait 4 cycles
			mov B,#01		; multiply x1 - doesn't affect A
			mov C,SDA		; transfer to C
			nop
			clr SCL
			rlc A
			mul AB			; wait 4 cycles
			mov B,#01		; multiply x1 - doesn't affect A
			djnz R5,CTI
			mul AB
			mov B,#01		; multiply x1 - doesn't affect A
			jb NOACK,ZPET	; don't send ACK
			clr SDA			; ACK from master
			nop
			nop
			nop
			setb SCL
			nop
			mul AB			; wait 4 cycles
			clr SCL

;			setb SDA			;????????????????
;			nop
;			nop

ZPET:		mov R7,A			; exchange register
			ret				; the end

END.















































































































































